/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TInputHelp.TInputHelpPath;
import de.ship.db.tables.records.TInputHelpparamRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TInputHelpparam extends TableImpl<TInputHelpparamRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_input_helpparam</code>
     */
    public static final TInputHelpparam T_INPUT_HELPPARAM = new TInputHelpparam();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TInputHelpparamRecord> getRecordType() {
        return TInputHelpparamRecord.class;
    }

    /**
     * The column <code>common_dd.t_input_helpparam.lastchange</code>.
     */
    public final TableField<TInputHelpparamRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_input_helpparam.pk</code>.
     */
    public final TableField<TInputHelpparamRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_input_helpparam.fk_study</code>. foreign key
     * to key_element of study
     */
    public final TableField<TInputHelpparamRecord, Integer> FK_STUDY = createField(DSL.name("fk_study"), SQLDataType.INTEGER.nullable(false), this, "foreign key to key_element of study");

    /**
     * The column <code>common_dd.t_input_helpparam.fk_variable</code>. foreign
     * key to key_element of parameter variable
     */
    public final TableField<TInputHelpparamRecord, Integer> FK_VARIABLE = createField(DSL.name("fk_variable"), SQLDataType.INTEGER.nullable(false), this, "foreign key to key_element of parameter variable");

    /**
     * The column <code>common_dd.t_input_helpparam.fk_inputhelp</code>. foreign
     * key to inputhelper this parameter belongs to
     */
    public final TableField<TInputHelpparamRecord, Integer> FK_INPUTHELP = createField(DSL.name("fk_inputhelp"), SQLDataType.INTEGER.nullable(false), this, "foreign key to inputhelper this parameter belongs to");

    /**
     * The column <code>common_dd.t_input_helpparam.order_nr</code>. order of
     * the parameter
     */
    public final TableField<TInputHelpparamRecord, Integer> ORDER_NR = createField(DSL.name("order_nr"), SQLDataType.INTEGER.nullable(false), this, "order of the parameter");

    private TInputHelpparam(Name alias, Table<TInputHelpparamRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TInputHelpparam(Name alias, Table<TInputHelpparamRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_input_helpparam</code> table
     * reference
     */
    public TInputHelpparam(String alias) {
        this(DSL.name(alias), T_INPUT_HELPPARAM);
    }

    /**
     * Create an aliased <code>common_dd.t_input_helpparam</code> table
     * reference
     */
    public TInputHelpparam(Name alias) {
        this(alias, T_INPUT_HELPPARAM);
    }

    /**
     * Create a <code>common_dd.t_input_helpparam</code> table reference
     */
    public TInputHelpparam() {
        this(DSL.name("t_input_helpparam"), null);
    }

    public <O extends Record> TInputHelpparam(Table<O> path, ForeignKey<O, TInputHelpparamRecord> childPath, InverseForeignKey<O, TInputHelpparamRecord> parentPath) {
        super(path, childPath, parentPath, T_INPUT_HELPPARAM);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TInputHelpparamPath extends TInputHelpparam implements Path<TInputHelpparamRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TInputHelpparamPath(Table<O> path, ForeignKey<O, TInputHelpparamRecord> childPath, InverseForeignKey<O, TInputHelpparamRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TInputHelpparamPath(Name alias, Table<TInputHelpparamRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TInputHelpparamPath as(String alias) {
            return new TInputHelpparamPath(DSL.name(alias), this);
        }

        @Override
        public TInputHelpparamPath as(Name alias) {
            return new TInputHelpparamPath(alias, this);
        }

        @Override
        public TInputHelpparamPath as(Table<?> alias) {
            return new TInputHelpparamPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TInputHelpparamRecord, Integer> getIdentity() {
        return (Identity<TInputHelpparamRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TInputHelpparamRecord> getPrimaryKey() {
        return Keys.PK_INPUT_HELPPARAM;
    }

    @Override
    public List<UniqueKey<TInputHelpparamRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_INPUT_HELPPARAM);
    }

    @Override
    public List<ForeignKey<TInputHelpparamRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_INPUT_HELPPARAM__FK_INPUTHELPPARAM_STUDY, Keys.T_INPUT_HELPPARAM__FK_INPUTHELPPARAM_VARIABLE, Keys.T_INPUT_HELPPARAM__FK_INPUTHELPPARAM_INPUTHELP);
    }

    private transient TCoreElementHierarchyPath _fkInputhelpparamStudy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table, via the
     * <code>fk_inputhelpparam_study</code> key.
     */
    public TCoreElementHierarchyPath fkInputhelpparamStudy() {
        if (_fkInputhelpparamStudy == null)
            _fkInputhelpparamStudy = new TCoreElementHierarchyPath(this, Keys.T_INPUT_HELPPARAM__FK_INPUTHELPPARAM_STUDY, null);

        return _fkInputhelpparamStudy;
    }

    private transient TCoreElementHierarchyPath _fkInputhelpparamVariable;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table, via the
     * <code>fk_inputhelpparam_variable</code> key.
     */
    public TCoreElementHierarchyPath fkInputhelpparamVariable() {
        if (_fkInputhelpparamVariable == null)
            _fkInputhelpparamVariable = new TCoreElementHierarchyPath(this, Keys.T_INPUT_HELPPARAM__FK_INPUTHELPPARAM_VARIABLE, null);

        return _fkInputhelpparamVariable;
    }

    private transient TInputHelpPath _tInputHelp;

    /**
     * Get the implicit join path to the <code>common_dd.t_input_help</code>
     * table.
     */
    public TInputHelpPath tInputHelp() {
        if (_tInputHelp == null)
            _tInputHelp = new TInputHelpPath(this, Keys.T_INPUT_HELPPARAM__FK_INPUTHELPPARAM_INPUTHELP, null);

        return _tInputHelp;
    }

    @Override
    public TInputHelpparam as(String alias) {
        return new TInputHelpparam(DSL.name(alias), this);
    }

    @Override
    public TInputHelpparam as(Name alias) {
        return new TInputHelpparam(alias, this);
    }

    @Override
    public TInputHelpparam as(Table<?> alias) {
        return new TInputHelpparam(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputHelpparam rename(String name) {
        return new TInputHelpparam(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputHelpparam rename(Name name) {
        return new TInputHelpparam(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputHelpparam rename(Table<?> name) {
        return new TInputHelpparam(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputHelpparam where(Condition condition) {
        return new TInputHelpparam(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputHelpparam where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputHelpparam where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputHelpparam where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputHelpparam where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputHelpparam where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputHelpparam where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputHelpparam where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputHelpparam whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputHelpparam whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
